Index: libroar/socket.c
===================================================================
--- libroar/socket.c	(revision 6052)
+++ libroar/socket.c	(revision 0)
@@ -1,217 +1,34 @@
 //socket.c:
 
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of libroar a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  libroar is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- *  NOTE for everyone want's to change something and send patches:
- *  read README and HACKING! There a addition information on
- *  the license of this document you need to read before you send
- *  any patches.
- *
- *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
- *  or libpulse*:
- *  The libs libroaresd, libroararts and libroarpulse link this lib
- *  and are therefore GPL. Because of this it may be illigal to use
- *  them with any software that uses libesd, libartsc or libpulse*.
- */
-
-#define _LIBROAR_NOATTR_TO_STATIC /* ignore warnings for TO_STATIC functions */
 #include "libroar.h"
 
-#if defined(ROAR_SUPPORT_PROXY) && !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER)
-#include <pwd.h>
-#endif
+#define MODE_LISTEN  1
+#define MODE_CONNECT 2
 
-#define MODE_LISTEN  ROAR_SOCKET_MODE_LISTEN
-#define MODE_CONNECT ROAR_SOCKET_MODE_CONNECT
+int roar_socket_new_tcp (void) {
+ int fh;
+// int extra_flags = TCP_NODELAY;
 
-static int roar_socket_open_file  (int mode, const char * host, int port);
+ fh = socket(PF_INET, SOCK_STREAM, 0);
 
-#ifdef ROAR_SUPPORT_PROXY
-static int roar_socket_open_proxy (int mode, int type, const char * host, int port, const char * proxy_type);
-
-static int roar_socket_open_socks4 (int mode, int fh, const char * host, int port, const char * user, const char * pw, const char * opts);
-static int roar_socket_open_socks4a(int mode, int fh, const char * host, int port, const char * user, const char * pw, const char * opts);
-static int roar_socket_open_socks4d(int mode, int fh, const char * host, int port, const char * user, const char * pw, const char * opts);
-static int roar_socket_open_socks4x(int mode, int fh, char host[4], int port, const char * app, size_t app_len, const char * user);
-
-static int roar_socket_open_http   (int mode, int fh, const char * host, int port, const char * user, const char * pw, const char * opts);
-
-#ifdef ROAR_HAVE_BIN_SSH
-static int roar_socket_open_ssh    (int mode, int fh, const char * host, int port, const char * user, const char * pw, const char * opts);
-#endif
-#endif
-
-
-#ifdef ROAR_TARGET_WIN32
-void roar_socket_win32_init (void) {
- static int inited = 0;
- WSADATA wsadata;
-
- if ( !inited ) {
-  WSAStartup(MAKEWORD(1,1) , &wsadata);
-  inited++;
- }
-}
-#else
-#define roar_socket_win32_init()
-#endif
-
-#ifdef ROAR_HAVE_LIBDNET
-static int roar_socket_decnet_set_timeout (int fh, time_t sec, int_least32_t usec) {
- struct timeval timeout = {sec, usec};
-
- return setsockopt(fh, SOL_SOCKET, SO_SNDTIMEO, &timeout, sizeof(timeout));
-}
-#endif
-
-static int roar_socket_set_tos(int fh) {
-#if defined(ROAR_HAVE_BSDSOCKETS) && !defined(ROAR_TARGET_WIN32)
- int opt = IPTOS_LOWDELAY;
- int ret;
-
- roar_err_clear_errno();
- ret = setsockopt(fh, IPPROTO_IP, IP_TOS, &opt, sizeof(int));
- if ( ret < 0 )
-  roar_err_from_errno();
-
- return ret;
-#else
- roar_err_set(ROAR_ERROR_NOSYS);
- return -1;
-#endif
+ return fh;
 }
 
-int roar_socket_new        (int type) {
-#ifdef ROAR_HAVE_BSDSOCKETS
- int sys_domain = -1, sys_type = -1, sys_protocol = 0;
+int roar_socket_new_unix (void) {
  int fh;
-#if defined(ROAR_HAVE_IPV4) && defined(TCP_NODELAY) && !defined(ROAR_TARGET_WIN32)
- int t   = 1;
-#endif
 
- switch (type) {
-  case ROAR_SOCKET_TYPE_NONE:
-  case ROAR_SOCKET_TYPE_GENSTR:
-    roar_err_set(ROAR_ERROR_INVAL);
-    return -1;
-   break;
-  case ROAR_SOCKET_TYPE_FILE:
-  case ROAR_SOCKET_TYPE_FORK:
-    roar_err_set(ROAR_ERROR_PERM);
-    return -1;
-   break;
-#ifdef ROAR_HAVE_IPV4
-  case ROAR_SOCKET_TYPE_TCP:
-    sys_domain = AF_INET; sys_type = SOCK_STREAM;
-   break;
-  case ROAR_SOCKET_TYPE_UDP:
-    sys_domain = AF_INET; sys_type = SOCK_DGRAM;
-   break;
-#endif
-#ifdef ROAR_HAVE_UNIX
-  case ROAR_SOCKET_TYPE_UNIX:
-    sys_domain = AF_UNIX; sys_type = SOCK_STREAM;
-   break;
-#endif
-#ifdef ROAR_HAVE_LIBDNET
-  case ROAR_SOCKET_TYPE_DECNET:
-    sys_domain = AF_DECnet; sys_type = SOCK_STREAM; sys_protocol = DNPROTO_NSP;
-   break;
-#endif
-#ifdef ROAR_HAVE_IPV6
-  case ROAR_SOCKET_TYPE_TCP6:
-    sys_domain = AF_INET6; sys_type = SOCK_STREAM;
-   break;
-  case ROAR_SOCKET_TYPE_UDP6:
-    sys_domain = AF_INET6; sys_type = SOCK_DGRAM;
-   break;
-#endif
-#ifdef ROAR_HAVE_IPX
-  case ROAR_SOCKET_TYPE_IPX:
-    sys_domain = AF_IPX; sys_type = SOCK_DGRAM; sys_protocol = AF_IPX;
-   break;
-#endif
-  case ROAR_SOCKET_TYPE_IPXSPX:
-  case ROAR_SOCKET_TYPE_LAT_SERVICE:
-  case ROAR_SOCKET_TYPE_LAT_REVERSE_PORT:
-  default:
-    roar_err_set(ROAR_ERROR_AFNOTSUP);
-    return -1;
-   break;
- }
-
- roar_socket_win32_init();
-
- roar_err_clear_all();
- fh = socket(sys_domain, sys_type, sys_protocol);
- if ( fh == -1 ) {
-  roar_err_update();
-  return -1;
- }
-
- // do the extra work we need to do for some socket types:
- switch (type) {
-#ifdef ROAR_HAVE_IPV4
-  case ROAR_SOCKET_TYPE_TCP:
-#if defined(TCP_NODELAY) && !defined(ROAR_TARGET_WIN32)
-   setsockopt(fh, IPPROTO_TCP, TCP_NODELAY, &t, sizeof(int));
-#endif
-  case ROAR_SOCKET_TYPE_UDP:
-#endif
-#ifdef ROAR_HAVE_IPV6
-  case ROAR_SOCKET_TYPE_TCP6:
-  case ROAR_SOCKET_TYPE_UDP6:
-#endif
-#if defined(ROAR_HAVE_IPV4) || defined(ROAR_HAVE_IPV6)
-    roar_socket_set_tos(fh);
-   break;
-#endif
-#ifdef ROAR_HAVE_LIBDNET
-  case ROAR_SOCKET_TYPE_DECNET:
-    roar_socket_decnet_set_timeout(fh, 300, 0);
-   break;
-#endif
- }
+ fh = socket(AF_UNIX, SOCK_STREAM, 0);
 
  return fh;
-#else
- roar_err_set(ROAR_ERROR_NOSYS);
- return -1;
-#endif
 }
 
-
 int roar_socket_nonblock(int fh, int state) {
-#if !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER) && defined(ROAR_HAVE_FCNTL)
  int flags;
 
  if ( (flags = fcntl(fh, F_GETFL, 0)) == -1 ) {
-  roar_err_from_errno();
   ROAR_ERR("roar_socket_nonblock(fh=%i, state=%i): Can not read flags: %s", fh, state, strerror(errno));
   ROAR_DBG("roar_socket_nonblock(fh=%i, state=%i) = -1", fh, state);
   return -1;
  }
-
- if ( !(flags & O_NONBLOCK) && state == ROAR_SOCKET_BLOCK )
-  return 0;
 
  flags |= O_NONBLOCK;
@@ -221,5 +38,4 @@
 
  if ( fcntl(fh, F_SETFL, flags) == -1 ) {
-  roar_err_from_errno();
   ROAR_ERR("roar_socket_nonblock(fh=%i, state=%i): Can not set flags: %s", fh, state, strerror(errno));
   ROAR_DBG("roar_socket_nonblock(fh=%i, state=%i) = -1", fh, state);
@@ -229,334 +45,21 @@
  ROAR_DBG("roar_socket_nonblock(fh=%i, state=%i) = 0", fh, state);
  return 0;
-#else
- ROAR_WARN("roar_socket_nonblock(*): no nonblocking IO support on win32, use a real OS");
- return -1;
-#endif
 }
 
-int roar_socket_dup_udp_local_end (int fh) {
-#if !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER) && defined(ROAR_HAVE_FCNTL)
- int                  n              = -1;
- int                  flags          = -1;
- struct sockaddr_in   socket_addr;
- socklen_t            len            = sizeof(struct sockaddr_in);
-
- if ( (flags = fcntl(fh, F_GETFL, 0)) == -1 ) {
-  ROAR_WARN("roar_socket_dup_udp_local_end(fh=%i): Can not read flags: %s", fh, strerror(errno));
- }
-
- if ( getsockname(fh, (struct sockaddr *)&socket_addr, &len) == -1 ) {
-  roar_err_from_errno();
-  return -1;
- }
-
- if ( socket_addr.sin_family != AF_INET ) {
-  roar_err_set(ROAR_ERROR_TYPEMM);
-  return -1;
- }
-
- n = roar_socket_new(ROAR_SOCKET_TYPE_UDP);
-
- if ( n == -1 )
-  return -1;
-
-//  if ( mode_func(fh, (struct sockaddr *)&socket_addr, sizeof(struct sockaddr_in)) == -1 ) {
- if ( bind(n, (struct sockaddr *)&socket_addr, len) == -1 ) {
-  roar_err_from_errno();
-  close(n);
-  return -1;
- }
-
- if ( flags != -1 ) {
-  if ( fcntl(fh, F_SETFL, flags) == -1 ) {
-   ROAR_WARN("roar_socket_dup_udp_local_end(fh=%i): Can not set flags: %s", fh, strerror(errno));
-   return -1;
-  }
- }
-
-
- return n;
-#else
- ROAR_WARN("roar_socket_dup_udp_local_end(*): this function is not supported on win32, use a real OS");
- return -1;
-#endif
-}
-
-
-#define _SCMR_CONTROLLEN (sizeof(struct cmsghdr) + sizeof(int))
-int roar_socket_send_fh (int sock, int fh, char * mes, size_t len) {
-#if !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER) && !defined(ROAR_OS_SUNOS) && !defined(ROAR_TARGET_OPENVMS)
- struct iovec     iov[1];
- struct msghdr    msg;
- char             cmptr_buf[_SCMR_CONTROLLEN];
- struct cmsghdr * cmptr = (struct cmsghdr *) cmptr_buf;
- char             localmes[1] = {0};
- int *            fhptr;
-
- ROAR_DBG("roar_socket_send_fh(sock=%i, fh=%i, mes=%p, len=%u) = ?", sock, fh, mes, len);
-
- if ( sock < 0 || fh < 0 )
-  return -1;
-
- if ( len == 0 ) {
-  len = 1;
-  mes = localmes;
- }
-
- memset(&msg,  0, sizeof(msg));
- memset(cmptr, 0, _SCMR_CONTROLLEN);
-
- iov[0].iov_base = mes;
- iov[0].iov_len  = len;
- msg.msg_iov     = iov;
- msg.msg_iovlen  = 1;
- msg.msg_name    = NULL;
- msg.msg_namelen = 0;
-
- cmptr->cmsg_level        = SOL_SOCKET;
- cmptr->cmsg_type         = SCM_RIGHTS;
- cmptr->cmsg_len          = _SCMR_CONTROLLEN;
- msg.msg_control          = (caddr_t) cmptr;
- msg.msg_controllen       = _SCMR_CONTROLLEN;
- fhptr                    = (int *)CMSG_DATA(cmptr);
- *fhptr = fh;
-
- return sendmsg(sock, &msg, 0);
-#else
- ROAR_ERR("roar_socket_send_fh(*): There is no UNIX Domain Socket support in win32, download a real OS.");
- return -1;
-#endif
-}
-
-int roar_socket_recv_fh (int sock,         char * mes, size_t * len) {
-#if !defined(ROAR_TARGET_WIN32) && !defined(ROAR_TARGET_MICROCONTROLLER) && !defined(ROAR_OS_SUNOS) && !defined(ROAR_TARGET_OPENVMS)
- struct iovec     iov[1];
- struct msghdr    msg;
- char             cmptr_buf[_SCMR_CONTROLLEN];
- struct cmsghdr * cmptr = (struct cmsghdr *) cmptr_buf;
- char             localmes[1];
- size_t           locallen[1] = {1};
- int *            fhptr;
-
- ROAR_DBG("roar_socket_recv_fh(sock=%i, mes=%p, len=%p) = ?", sock, mes, len);
-
- if ( sock < 0 ) {
-  ROAR_DBG("roar_socket_recv_fh(sock=%i, mes=%p, len=%p) = -1 // invalid socket", sock, mes, len);
-  return -1;
- }
-
- if ( len == NULL ) {
-  len = locallen;
-  mes = localmes;
- }
-
- iov[0].iov_base = mes;
- iov[0].iov_len  = *len;
- msg.msg_iov     = iov;
- msg.msg_iovlen  = 1;
- msg.msg_name    = NULL;
- msg.msg_namelen = 0;
-
- msg.msg_control    = (caddr_t) cmptr;
- msg.msg_controllen = _SCMR_CONTROLLEN;
-
- if ( (*len = recvmsg(sock, &msg, 0)) == -1 ) {
-  ROAR_DBG("roar_socket_recv_fh(sock=%i, mes=%p, len=%p) = -1 // can not read from socket", sock, mes, len);
-  return -1;
- }
-
- if ( msg.msg_controllen  < _SCMR_CONTROLLEN ||
-      cmptr->cmsg_len    != _SCMR_CONTROLLEN  ) {
-  ROAR_DBG("roar_socket_recv_fh(sock=%i, mes=%p, len=%p) = -1 // control len is wrong", sock, mes, len);
-  return -1;
- }
-
- fhptr = (int *)CMSG_DATA(cmptr);
- ROAR_DBG("roar_socket_recv_fh(sock=%i, mes=%p, len=%p) = %i", sock, mes, len, *fhptr);
- return *fhptr;
-#else
- ROAR_ERR("roar_socket_recv_fh(*): There is no UNIX Domain Socket support in win32, download a real OS.");
- return -1;
-#endif
-}
-
-int roar_socket_listen  (int type, const char * host, int port) {
+int roar_socket_listen  (int type, char * host, int port) {
  return roar_socket_open(MODE_LISTEN, type, host, port);
 }
 
-int roar_socket_connect (int type, const char * host, int port) {
- const char * proxy_type = roar_env_get("ROAR_PROXY");
-
- ROAR_DBG("roar_socket_connect(host='%s', port=%i) = ?", host, port);
-
- if ( proxy_type == NULL || strcmp(proxy_type, "") == 0 ) {
-  return roar_socket_open(MODE_CONNECT, type, host, port);
- } else {
-#ifdef ROAR_SUPPORT_PROXY
-  return roar_socket_open_proxy(MODE_CONNECT, type, host, port, proxy_type);
-#else
-  ROAR_ERR("roar_socket_connect(host='%s', port=%i): no support for proxy code (proxy_type=%s)", host, port, proxy_type);
-  return -1;
-#endif
- }
+int roar_socket_connect (char * host, int port) {
+ return roar_socket_open(MODE_CONNECT, ROAR_SOCKET_TYPE_UNKNOWN, host, port);
 }
 
-
-#ifdef ROAR_HAVE_LIBDNET
-static int roar_socket_listen_decnet (const char * object, int num) {
- int fh = roar_socket_new(ROAR_SOCKET_TYPE_DECNET);
- struct sockaddr_dn bind_sockaddr;
-
- if ( fh == -1 )
-  return -1;
-
- if ( object != NULL && !*object )
-  object = NULL;
-
- if ( (object != NULL && num) || (object != NULL && !*object && !num) || (object == NULL && !num) ) {
-  ROAR_WARN("roar_socket_listen_decnet(object='%s', num=%i): illegal address!", object, num);
-  close(fh);
-  roar_err_set(ROAR_ERROR_INVAL);
-  return -1;
- }
-
- memset((void*)&bind_sockaddr, 0, sizeof(struct sockaddr_dn));
-
- bind_sockaddr.sdn_family    = AF_DECnet;
- bind_sockaddr.sdn_flags     = 0;
- bind_sockaddr.sdn_objnum    = num;
-
- if ( num ) {
-  bind_sockaddr.sdn_objnamel = 0;
- } else {
-  bind_sockaddr.sdn_objnamel  = ROAR_HOST2LE16(strlen(object));
-  if ( bind_sockaddr.sdn_objnamel > DN_MAXOBJL )
-   bind_sockaddr.sdn_objnamel = DN_MAXOBJL;
-  strncpy((char*)bind_sockaddr.sdn_objname, object, DN_MAXOBJL);
- }
-
- if ( bind(fh, (struct sockaddr *) &bind_sockaddr, sizeof(bind_sockaddr)) == -1 ) {
-  roar_err_from_errno();
-  close(fh);
-  return -1;
- }
-
- if ( listen(fh, 8) == -1 ) {
-  roar_err_from_errno();
-  close(fh);
-  return -1;
- }
-
- return fh;
-}
-#endif
-
-const char * roar_socket_get_local_nodename(void) {
-#ifdef ROAR_HAVE_LIBDNET
- static char node[16] = {0};
- struct dn_naddr      *binaddr;
- struct nodeent       *dp;
-
- if ( !node[0] ) {
-
- // TODO: This does this function not use getnodename()?
-
- // Those strange workarounds for the error codes are because those functions currently
- // don't set errno. This way we will use errno as soon as it starts to set it.
-
-  roar_err_update();
-  if ( (binaddr=getnodeadd()) == NULL) {
-   roar_err_update();
-   if ( roar_error == ROAR_ERROR_NONE )
-    roar_err_set(ROAR_ERROR_NOENT);
-   return NULL;
-  }
-
-  roar_err_update();
-  if ( (dp=getnodebyaddr((char*)binaddr->a_addr, binaddr->a_len, AF_DECnet)) == NULL ) {
-   roar_err_update();
-   if ( roar_error == ROAR_ERROR_NONE )
-    roar_err_set(ROAR_ERROR_NOENT);
-   return NULL;
-  }
-
-  strncpy(node, dp->n_name, 15);
-  node[15] = 0;
- }
-
- return node;
-#else
- roar_err_set(ROAR_ERROR_AFNOTSUP);
- return NULL;
-#endif
-}
-
-int roar_socket_open (int mode, int type, const char * host, int port) {
+int roar_socket_open (int mode, int type, char * host, int port) {
 // int type = ROAR_SOCKET_TYPE_INET;
  int fh;
-#ifdef ROAR_HAVE_IPX
-#define _NEED_OBJ
-#endif
-#if defined(ROAR_HAVE_IPX) || defined(ROAR_HAVE_GETADDRINFO)
- int ret;
-#endif
-#ifdef ROAR_HAVE_IPX
- unsigned int ipx_port;
-#endif
-#ifdef ROAR_HAVE_UNIX
- int abstract = 0;
-#endif
-#if defined(ROAR_HAVE_IPV4) || defined(ROAR_HAVE_IPV6) || defined(ROAR_HAVE_UNIX) || defined(ROAR_HAVE_IPX)
- union {
-  struct sockaddr     sa;
-#if defined(ROAR_HAVE_IPV4) || defined(ROAR_HAVE_IPV6)
-  struct sockaddr_in  in;
-#endif
-#ifdef ROAR_HAVE_UNIX
-  struct sockaddr_un  un;
-#endif
-#ifdef ROAR_HAVE_IPV6
-  struct sockaddr_in6 in6;
-#endif
-#ifdef ROAR_HAVE_IPX
-  struct sockaddr_ipx ipx;
-#endif
- } socket_addr;
- socklen_t addrlen;
-#endif
-#if (defined(ROAR_HAVE_IPV4) || defined(ROAR_HAVE_IPV6)) && !defined(ROAR_HAVE_GETADDRINFO)
- struct hostent     * he = NULL;
-#endif
-#ifdef ROAR_TARGET_WIN32
- int PASCAL (*mode_func)(SOCKET,const struct sockaddr*,int) = connect; // default is to connect
-#else
+ struct sockaddr_in   socket_addr;
+ struct hostent     * he;
+ //unsigned int host_div = 0;
  int (*mode_func)(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen) = connect; // default is to connect
-#endif
-#ifdef ROAR_HAVE_LIBDNET
-#define _NEED_OBJ
- char * dnet_node_buf;
- char * del;
-#endif
-#ifdef _NEED_OBJ
- char obj[80];
-#endif
-#ifdef ROAR_HAVE_GETADDRINFO
- int af_guessed = 0;
- struct addrinfo hints, *res = NULL;
- char port_as_string[32];
-#endif
-#if defined(ROAR_HAVE_IPV4) || defined(ROAR_HAVE_IPV6)
- int is_numerical = 1;
- const char * numptr;
-#endif
-
- ROAR_DBG("roar_socket_open(mode=%i, type=%i, host='%s', port=%i) = ?", mode, type, host, port);
-
- if ( host == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- roar_err_set(ROAR_ERROR_UNKNOWN);
 
  if ( mode == MODE_LISTEN )
